package com.tashow.cloud.product.service.impl;

import com.tashow.cloud.product.dto.SkuServiceDeliverDO;
import com.tashow.cloud.product.mapper.SkuServiceDeliverMapper;
import com.tashow.cloud.product.service.SkuServiceDeliverService;
import com.tashow.cloud.product.vo.skuservicedeliver.SkuServiceDeliverPageReqVO;
import com.tashow.cloud.product.vo.skuservicedeliver.SkuServiceDeliverSaveReqVO;
import com.tashow.cloud.productapi.enums.ErrorCodeConstants;
import org.springframework.stereotype.Service;
import jakarta.annotation.Resource;
import org.springframework.validation.annotation.Validated;
import org.springframework.transaction.annotation.Transactional;

import java.util.*;
import com.tashow.cloud.common.pojo.PageResult;
import com.tashow.cloud.common.pojo.PageParam;
import com.tashow.cloud.common.util.object.BeanUtils;


import static com.tashow.cloud.common.exception.util.ServiceExceptionUtil.exception;

/**
 * 服务交付方式 Service 实现类
 *
 * @author 芋道源码
 */
@Service
@Validated
public class SkuServiceDeliverServiceImpl implements SkuServiceDeliverService {

    @Resource
    private SkuServiceDeliverMapper skuServiceDeliverMapper;

    @Override
    public Long createSkuServiceDeliver(SkuServiceDeliverSaveReqVO createReqVO) {
        // 插入
        SkuServiceDeliverDO skuServiceDeliver = BeanUtils.toBean(createReqVO, SkuServiceDeliverDO.class);
        skuServiceDeliverMapper.insert(skuServiceDeliver);
        // 返回
        return skuServiceDeliver.getId();
    }

    @Override
    public void updateSkuServiceDeliver(SkuServiceDeliverSaveReqVO updateReqVO) {
        // 校验存在
        validateSkuServiceDeliverExists(updateReqVO.getId());
        // 更新
        SkuServiceDeliverDO updateObj = BeanUtils.toBean(updateReqVO, SkuServiceDeliverDO.class);
        skuServiceDeliverMapper.updateById(updateObj);
    }

    @Override
    public void deleteSkuServiceDeliver(Long id) {
        // 校验存在
        validateSkuServiceDeliverExists(id);
        // 删除
        skuServiceDeliverMapper.deleteById(id);
    }

    private void validateSkuServiceDeliverExists(Long id) {
        if (skuServiceDeliverMapper.selectById(id) == null) {
            throw exception(ErrorCodeConstants.SKU_SERVICE_DELIVER_NOT_EXISTS);
        }
    }

    @Override
    public SkuServiceDeliverDO getSkuServiceDeliver(Long id) {
        return skuServiceDeliverMapper.selectById(id);
    }

    @Override
    public PageResult<SkuServiceDeliverDO> getSkuServiceDeliverPage(SkuServiceDeliverPageReqVO pageReqVO) {
        return null;
    }

}